#include <stdlib.h>
#include <stdio.h>
#include "pngio.h"
#include "gfx.h"
#include "gmap.h"
#include "bitmap.h"
#include "exops.h"

#define SCR_W 1000
#define SCR_H 800

#define PAD 10

#define BUT_X  PAD
#define BUT_W  100
#define BUT_H  30

#define SCV_X  (SCR_W-1-gui_scrollbar_width)
#define SCH_Y  (SCR_H-1-gui_scrollbar_height)

#define ARE_X  (PAD+BUT_W+PAD+1)
#define ARE_Y  (PAD+1)
#define ARE_W  (SCV_X - 1 - ARE_X)
#define ARE_H  (SCH_Y - 1 - ARE_Y)

#define ICO_W  BUT_W
#define ICO_X  BUT_X
#define ICO_H  ICO_W
#define ICO_Y  (SCH_Y-1-ICO_H)

#define WHITE 0xffffff

enum { GB_CROP= GFXEV_LAST+1, GB_HORZ, GB_VERT,
       GB_HORLINE, GB_REMORECT, GB_VERLINE, GB_REMOLINE, 
       GB_FINDCON,GB_REMOCON, GB_SAVE , GB_PICT};
typedef struct { char *name; int action; } btn_t;

btn_t butcol1[]=
 {
   {"Crop", GB_CROP},
   {"HorLine", GB_HORLINE}, 
   {"VerLine", GB_VERLINE}, 
   {"RemLine", GB_REMOLINE}, 
   {"RemRect", GB_REMORECT}, 
   {"FinConn", GB_FINDCON},
   {"RemConn", GB_REMOCON},
   {"Save",    GB_SAVE},
   {"FinPict", GB_PICT},
   { NULL, 0 }
 };

int sch, scv, lax, lay;
unsigned int *image, image_w, image_h;
unsigned int image_x, image_y;
unsigned char *gdata;
gmap_t gmap;

int hor_line_thr= 50;

double dmin2(double a,double b) { return a<b?a:b; }


void show_scr()
{
   int y;
   int i;
   double end;
   btn_t *buts;
   gfx_fill_rect(0,0,0,SCR_W,SCR_H, 0xededed);
   y= PAD;
   buts= butcol1;
   for(i=0;buts[i].name;i++)
   {
     gfx_button(0, BUT_X, y, BUT_W, BUT_H, buts[i].name, buts[i].action);
     y+= BUT_H + PAD;
   }

   if (image_h) end= dmin2(1.0,(double) ARE_H/image_h); else end= 1.0;
   scv= gfx_scrollbar(GFX_UPDATE | GFX_VERTICAL, SCV_X, ARE_Y-1,
                      gui_scrollbar_width, ARE_H+1,
                      0.0, end, 0.1, GB_VERT);
   if (image_w) end= dmin2(1.0,(double) ARE_W/image_w); else end= 1.0;
   sch= gfx_scrollbar(GFX_UPDATE | GFX_HORIZONTAL, ARE_X-1, SCH_Y, 
                      ARE_W+1, gui_scrollbar_height,
                      0.0, end, 0.1, GB_HORZ);
   gfx_draw_rect(0, ARE_X-1, ARE_Y-1, ARE_W+2, ARE_H+2, 0);

   lax= gfx_label(0,1,0, 0xededed, BUT_X, y, BUT_W, BUT_H, "X: ");
   y+= BUT_H;
   lay= gfx_label(0,1,0, 0xededed, BUT_X, y, BUT_W, BUT_H, "Y: ");

   gfx_draw_rect(0, ICO_X-1, ICO_Y-1, ICO_W+2, ICO_H+2, 0);
   gfx_fill_rect(0, ICO_X, ICO_Y, ICO_W, ICO_H, 0xffffff);
}


int imin2(int a,int b) { return a<b?a:b; }
int imax2(int a,int b) { return a>b?a:b; }

void show_image(int update)
{
  int copy_w, copy_h;
  if (!image || !image_w || !image_h) return ;

  copy_w= imin2(image_w - image_x, ARE_W);
  copy_h= imin2(image_h - image_y, ARE_H);
  // gfx_fill_rect(0, ARE_X,ARE_Y, ARE_W,ARE_H, 0xededed);
  gfx_put(0, image, image_w, image_h, image_x, image_y, ARE_X, ARE_Y, 
                    copy_w, copy_h);
  if (update)
    gfx_update(ARE_X,ARE_Y,ARE_W,ARE_H);
}


void set_scrollbars()
{
  double st, en;

  st= 0.0; en= 1.0;
  if (image_h) { st= image_y / (double) image_h;
                 en= dmin2(1.0,(image_y+ARE_H)  / (double) image_h); }
  gfx_scrollbar_set(GFX_UPDATE, scv, st, en,0.1);

  st= 0.0; en= 1.0;
  if (image_w) { st= image_x / (double) image_w;
                 en= dmin2(1.0,(image_x+ARE_W)  / (double) image_w); }
  gfx_scrollbar_set(GFX_UPDATE, sch, st, en,0.1);
}

void make_visible(int vx,int vy)
{
  if (vx>=image_x && vx<(image_x+ARE_W) 
      && vy>=image_y && vy<(image_y+ARE_H)) goto done;

  if (vx<image_x || vx>=(image_x+ARE_W)) 
      image_x= imax2(0, imin2(image_w-ARE_W, vx - ARE_W/2));

  if (vy<image_y || vy>=(image_y+ARE_H))
      image_y= imax2(0, imin2(image_h-ARE_H, vy- ARE_H/2));

  set_scrollbars();
done:
  show_image(1);
}

pect_t PR;
int recSx, recEx, recSy, recEy;


void mark_pect()
{
  int sx,sy,ex,ey;
  int x,y;
  sx= PR.x0;
  sy= PR.y0;
  ex= PR.x1;
  ey= PR.y1;
  for(y=sy;y<ey;y++)
   for(x=sx;x<ex;x++)
     image[y*image_w+x] = 0xff0000;
  make_visible(sx,sy);
}

void reload_pect(int upd)
{
  int sx,sy,ex,ey;
  int x,y;
  sx= PR.x0;
  sy= PR.y0;
  ex= PR.x1;
  ey= PR.y1;
  for(y=sy;y<ey;y++)
   for(x=sx;x<ex;x++)
     image[y*image_w+x] = 0xff000000 | 
                          (gmap.data[x+image_w*y] << 16) |
                          (gmap.data[x+image_w*y] << 8) |
                          (gmap.data[x+image_w*y]);
  if (upd)
    make_visible(sx,sy);
}

void reload_all(int upd)
{
  PR.x0= 0; PR.y0= 0; PR.x1= image_w; PR.y1= image_h;
  reload_pect(upd);
}

void showcrop()
{
  pect_t P;
  if (!crop(&gmap, &P, 0xff)) return ;
  free(image);
  image= malloc(sizeof(unsigned int)*gmap.w*gmap.h);
  image_w= gmap.w;
  image_h= gmap.h;
  image_x= 0;
  image_y= 0;
  if (image_w<ARE_W || image_h<ARE_H)
     gfx_fill_rect(0, ARE_X,ARE_Y, ARE_W,ARE_H, 0xededed);
  gfx_scrollbar_set(GFX_UPDATE, scv, 0.0, dmin2(1.0,(double)ARE_H/image_h),0.1);
  gfx_scrollbar_set(GFX_UPDATE, sch, 0.0, dmin2(1.0,(double)ARE_W/image_w),0.1);
  reload_all(1);
}





int main(int argc,char **argv)
{
  gfx_event_t event;
  char *ie;
  int SS;
  unsigned int pc;

  gfx_init(NULL, SCR_W, SCR_H, "Text Extractor");

  {
    // This is here to test the graymap reading stuff. I could easily
    // do it with the read_image() function.
    ie= read_png_graymap_noalpha(argv[1], &image_w, &image_h, &gdata);
    if (ie)
    {
      printf("png error: %s\n", ie);
      image_w= image_h= 0;
      image= NULL;
      goto noimg;
    }
    image= malloc(sizeof(unsigned int)*image_w*image_h);
    gmap.w= image_w; gmap.h= image_h;
    gmap.data= gdata;

    reload_all(0);
  }
noimg:
  show_scr();
  show_image(0);
  gfx_update_all();
             int x,y; char buf[20];
  while(1)
   if (gfx_event(NULL,&event))
   switch(event.type)
   {
     case GFXEV_QUIT: goto done;
     case GB_VERT:
              if (image_h<=ARE_H) break;
              image_y= event.flo0 * image_h;
              if (image_y+ARE_H>image_h) image_y= image_h - ARE_H;
              show_image(1); break;
     case GB_HORZ:
              if (image_w<=ARE_W) break;
              image_x= event.flo0 * image_w;
              if (image_x+ARE_W>image_w) image_x= image_w - ARE_W;
              show_image(1); break;
     case GB_CROP: showcrop(); break;
     case GFXEV_POINTER_MOVE:
           x= event.x; y= event.y;
           if (x>=ARE_X && x<(ARE_X+ARE_W) && y>=ARE_Y && y<(ARE_Y+ARE_H))
           {
             x= x - ARE_X + image_x;
             y= y - ARE_Y + image_y;
             sprintf(buf,"X: %d",x); 
             gfx_label_set_text(GFX_UPDATE, lax, buf);
             sprintf(buf,"Y: %d",y); 
             gfx_label_set_text(GFX_UPDATE, lay, buf);
           }
           break;
     case GB_HORLINE:
           SS= 0;
           if (find_hor_line(&gmap,&PR,0xff, hor_line_thr,&SS,&pc)) mark_pect();
           break;
     case GB_VERLINE: 
           SS= 0;
           if (find_ver_line(&gmap,&PR,0xff, hor_line_thr,&SS,&pc)) mark_pect();
           break;
     case GB_REMORECT: 
           gmap_clear(&gmap, &PR, 0xff);
           reload_pect(1);
           break;
     case GFXEV_KEY_PRESS:
           if (event.key!=GFX_K_RETURN) break;
           else
           {
             static int ku;
             ku++;
             if (!(ku&1)) { 
               gmap_clear(&gmap, &PR, gmap_choose_bg(&gmap,&PR,0xff,0x00));
               reload_pect(1);
               break;
             }
           }
     case GB_FINDCON: 
           SS= 0;
           if (find_connected(&gmap,&PR,0,&SS)) 
           {
             mark_pect();
             unsigned char *bmap; int blen;
             bmap= graymap_to_bitmap(gmap.data, gmap.w, gmap.h,
                                 PR.x0, PR.y0, PR.x1-PR.x0, PR.y1-PR.y0,
                                 0, &blen);
             unsigned char *G; int Gw, Gh;
             G= bitmap_to_graymap(bmap, &Gw, &Gh);
             gfx_fill_rect(0, ICO_X,ICO_Y, ICO_W, ICO_H, 0xffffff);
             gfx_put_graymap(0, G, Gw, Gh, 0,0, ICO_X,ICO_Y, Gw,Gh);
             gfx_update(ICO_X,ICO_Y, ICO_W, ICO_H);
           }
           break;
     case GB_REMOLINE: 
           SS= 0;
           while (find_hor_line(&gmap,&PR,0xff, hor_line_thr,&SS,&pc))
             gmap_clear(&gmap, &PR, 0xff);
           SS= 0;
           while (find_ver_line(&gmap,&PR,0xff, hor_line_thr,&SS,&pc))
             gmap_clear(&gmap, &PR, 0xff);
           reload_all(1);
           break;
     case GB_REMOCON:
           SS= 0;
           while (find_connected(&gmap,&PR,0,&SS))
             gmap_clear(&gmap, &PR, gmap_choose_bg(&gmap,&PR,0xff,0x00));
           reload_all(1);
           break;
     case GB_SAVE:
         ie= write_png_image("out.png", image_w, image_h, image);
         if (ie)
         {
            printf("png error: %s\n", ie);
         }
         break;
     case GB_PICT:
         SS= 0;
         if (partition(&gmap,&PR,0xff,&SS)) mark_pect();
         break;
   }
done:
  printf("Bye!\n");
  gfx_close();
  return 0;
  
}


/* Now I can go on with encoding and unifying bitmaps.

  A bitmap shall be encoded as:

    width(4 bytes) height(4 bytes) ... data

  I can easily use the strmap stuff for this. no problem.

  In any case, my work still isn't done. I need to
   - partition the remaining image
   - see if it has any big uniform rectangles
   - remove those and partition again
   - see if our images can be found in the graymap list.
   - yeah this is ok..
*/

